;A86 LESFIX.ASM
;Fix para: Les Manley in: Search for the King
;testeado en: v2.0, v1.1
;vlan7, diciembre 2020

org 100h                                ;.COM

;****************************************
;*                                      *
;*   C O D I G O    R E S I D E N T E   *
;*                                      *
;****************************************
@@start:    jmp near @@init             ;saltar a instalacion/old handler
    dw  0                               ;extra word para far jmp segment

new21   proc    far
;¿es la v1.1 o v2.0 del juego?
;si, parchear en memoria, una instruccion del juego por la instruccion "INT 60"
;no, continuar
    cmp ah,48h                          ;¿allocate memory?
    jne @@start
    push    ds,si
    push word ss:[bp+4]                 ;el segmento donde parchear
    pop ds
    mov si,_offset_v2
    cmp word [si],0fa8bh                ;¿mov di,dx?
    jne @@v11
    cmp word [si-2],0f38bh              ;¿mov si,bx?
    jne @@v11
    mov word [si],60cdh                 ;patch!
    jmp short @@done
@@v11:  mov si,_offset_v11
    cmp word [si],0fa8bh                ;¿mov di,dx?
    jne @@done
    cmp word [si-2],0f38bh              ;¿mov si,bx?
    jne @@done
    mov word [si],60cdh                 ;patch!
@@done: pop si,ds
    jmp	short @@start                   ;continuar
new21   endp

new60   proc    far
;¿estamos en la habitacion del hotel y se ha introducido "sit"/"sit down"?
;si, sustituir en memoria "sit\x00" o "sit\x20down\x00" por "sit\x20bed\x00"
;no, bye
    mov di,dx                           ;instruccion parcheada con CD 60
    push    ds,si
    lds si,[bp+6]                       ;el segmento donde parchear
    cmp si,_offset_comando              ;¿es un comando?
    jne @@exit60
;54 79 70 69 63 61 6C 20 52 6F 6F 6D 00
;T  y  p  i  c  a  l  20 R  o  o  m  0
    cmp word [_offset_room],7954h       ;¿estamos en habitacion hotel?
    jne @@exit60
;73 69 74 20 64 6F 77 6E 00
;s  i  t  20 d  o  w  n  0
    cmp word [si],6973h                 ;¿"sit\x00"?
    jne @@exit60
    cmp word [si+2],0074h
    je @@patch60
    cmp word [si+3],6420h               ;¿"sit\x20down\x00"?
    jne @@exit60
    cmp word [si+5],776fh
    jne @@exit60
    cmp word [si+7],6eh
    jne @@exit60
;73 69 74 20 62 65 64 00
;s  i  t  20 b  e  d  0
@@patch60:  mov word [si+3],6220h       ;write "\x20bed\x00" to memory
    mov word [si+5],6465h
    mov byte [si+7],0
@@exit60:   pop si,ds
    iret                                ;volver al juego
new60   endp

;***************************************
;*                                     *
;*   I N S T A L A C I O N    T S R    *
;*                                     *
;***************************************
;;autocomprobarse en memoria
@@init: mov ax,3521h                ;get @int21
    int 21h                         ;puntero en es:bx
    cmp word es:[bx+1],48fch        ;¿estoy ya residente?
    jne @@isr_install
    mov dx,offset msgresidente      ;si, bye
    mov ah,9                        ;print string
    int 21h
    mov ah,4ch                      ;salir al DOS
    int 21h

@@isr_install:  inc byte @@start    ;crear salto a antigua int21
    mov word @@start+1,bx
    mov word @@start+3,es
    mov dx,offset new21
	mov ah,25h                      ;set @int21, ojo! asegurate de que AL=21
	int 21h
	mov al,60h                      ;set @int60
    mov dx,offset new60
    int 21h
    mov es,ds:[2ch]                 ;@entorno
    mov ah,49h                      ;liberar espacio entorno
    int 21h
    mov dx,offset @@init            ;fin codigo residente
    add dx,0fh                      ;redondeo a parrafo
    mov cl,4
    shr dx,cl                       ;bytes->parrafos
    mov ax,3100h                    ;terminar, dejar DX parrafos residentes
    int 21h

;***********************************************
;*                                             *
;*   D A T O S    N O    R E S I D E N T E S   *
;*                                             *
;***********************************************
_offset_comando     equ 1eah
_offset_room        equ 29eah
_offset_v2          equ 6d0fh
_offset_v11         equ 6d07h
msgresidente        db  "ya estoy en memoria, nothing todo. bye",0dh,0ah,"$"
